﻿using System;
using System.Diagnostics;

// ReSharper disable StringLiteralTypo

namespace CueSplitter.Helpers
{
    internal static class FfMpegHelper
    {
        public static string[] CutSegment(string inputFilePath, string outputFilePath, TimeSpan offset, TimeSpan duration)
        {
            return new string[]
            {
                "-n","-hide_banner","-stats",
                "-v","warning",
                "-i", inputFilePath,
                "-c", "copy",
                "-ss",offset.ToFfMpegTimeStamp(),
                "-t",duration.ToFfMpegTimeStamp(),
                outputFilePath
            };
        }

        private static string ToFfMpegTimeStamp(this TimeSpan t) => $"{t.Hours:00}:{t.Minutes:00}:{t.Seconds:00}.{t.Milliseconds:000}";

        public static Process Launch(string[] args)
        {
            var process = new Process
            {
                StartInfo =
                {
                    FileName = "ffmpeg",
                    CreateNoWindow = false,
                    UseShellExecute = false,
                }
            };
            foreach (var item in args) process.StartInfo.ArgumentList.Add(item);
            process.Start();
            return process;
        }
    }
}
